*-- Author :    Hartwig Albrecht   16/03/95

      SUBROUTINE DFFILE1 (LINK, CSTR, INOT)

************************************************************************
*
* Description: handle input/output bits for tables
*   This Fortran routine is only a temporary solution and should be replaced
*   by the corresponding code in C, directly placed into dftabl.
*
* Called from: DFFILE (q.v.)
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZMMCOM.fi"
#include "auto/MEMO.fi"
#include "auto/MEIO.fi"

#ifdef _LINUX_
      INTEGER IOR
#endif

      INTEGER LINK, I, INOT, IBIT, LENOCC
      CHARACTER CSTR*(*),CC*80

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEIO.ff"

      IF (CSTR(1:LENOCC(CSTR)) .EQ. 'INPUT')  THEN
        IBIT = 1
      ELSE IF (CSTR(1:LENOCC(CSTR)) .EQ. 'OUTPUT')  THEN
        IBIT = 2
      ELSE
        DO 20 IBIT = 3, NMMLUN
          CALL CHHTOC (IQ(HQMEIO_STREAM(1,IMMLUN(IBIT))), CC)
 20     IF (CSTR .EQ. CC)  GO TO 30
        IF (NMMLUN .EQ. 32)  THEN
          CALL MEERRC (396745,
     +  'DFFILE: 30 Zebra input/output units requested - too many')
          GO TO 90
        END IF

        NMMLUN = NMMLUN + 1
        IBIT = NMMLUN
        CALL IOFIND (CSTR, IMMLUN(IBIT))
        IQ(HQMEIO_BIT(IMMLUN(IBIT))) = IBIT
      END IF

 30   IF (INOT .EQ. 0)  THEN
        IQ(BQMEMO_IOD(LINK)) = IOR (BMEMO_IOD(LINK), BIT(IBIT))
      ELSE
        IQ(BQMEMO_IOD(LINK)) = 
     +    IAND (BMEMO_IOD(LINK), NOT(BIT(IBIT)))
      END IF

 90   END

************************************************************************
* End of DFFILE1
************************************************************************
