
/**********************************************************************/
//
// $Source: /afs/desy.de/group/hera-b/repository/ARTE/cluearte/Cluster.C,v $
// $Revision: 1.4 $
// $Author: natasha $
// $Date: 1999/08/31 10:43:01 $
//
// Created: 07-23-99,   C. Borgmeier
//
/**********************************************************************/



#include <arte/arte.hh>
#include <Clue/Cluster.hh>


EcalCluster::EcalCluster(ArtePointer<RCCL> rccl)
  :Point3D(rccl->x, rccl->y, rccl->z),
   esum( rccl->esum ),
   wid(  rccl->wid ),
   asym( rccl->asym ),
   flag( rccl->flag ),
   lemp( rccl->lemp ),
   lhad( rccl->lhad )
{
  for( int i=0; i<15; ++i ) cve[i] = rccl->cve[i];
}
