
// *****************************************************************************
//
// source:    faCatchSIG.C
//
// type:      source code
//
// created:   23 Sep 1997
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// changes:         
// 23 Feb 1999 (AG) include prototypes here
// 11 Mar 1999 (AG) polishing
// 25 Mar 1999 (AG) use atstopc_()
// 01 Jun 1999 (AG) put includes
// 18 Aug 1999 (AG) provide only one signal catching routine
// 02 Sep 1999 (AG) fixed segmentation violation problem
// 07 Sep 1999 (AG) use atstopcc_( char * )
//
// *****************************************************************************

// includes
#include <iostream>

#include <signal.h>
#include <string.h>

#include "farm/fa.hh"

// C prototypes
extern "C" void atstopcc_( char *txt );

//
// program code
//
void
faCatchSIG( int sig )
{
#ifdef _OUT_
  cout << "faCatchSIG(): sig=" << sig << " Invoking atstopcc_()" << endl;
#endif
  char *txt = "faCatchSIG()";
  atstopcc_( txt );
}
