      SUBROUTINE PTLREA
************************************************************************
*                                                                      *
* PPPPPPPPP   TTTTTTTTTT  LL        RRRRRRRRR   EEEEEEEEEE   AAAAAAAA  *
* PPPPPPPPPP  TTTTTTTTTT  LL        RRRRRRRRRR  EEEEEEEEEE  AAAAAAAAAA *
* PP      PP      TT      LL        RR      RR  EE          AA      AA *
* PP      PP      TT      LL        RR      RR  EE          AA      AA *
* PP      PP      TT      LL        RR      RR  EE          AA      AA *
* PPPPPPPPPP      TT      LL        RRRRRRRRRR  EEEEEE      AAAAAAAAAA *
* PPPPPPPPP       TT      LL        RRRRRRRRR   EEEEEE      AAAAAAAAAA * 
* PP              TT      LL        RR  RR      EE          AA      AA *
* PP              TT      LL        RR   RR     EE          AA      AA *
* PP              TT      LL        RR    RR    EE          AA      AA *
* PP              TT      LLLLLLLL  RR     RR   EEEEEEEEEE  AA      AA *
* PP              TT      LLLLLLLL  RR      RR  EEEEEEEEEE  AA      AA *
*                                                                      *
************************************************************************
*                                                                      *
* Revision: 1.1.1.1 $                                                  *
* Author: I.Belyaev                                                    *
* Date: 1997/11/06 09:52:46 $                                          *
*                                                                      *
* Created: Apr 10, 1997 by I.Belyaev                                   *
*                                                                      *
* Description:                                                         *
*                                                                      *
* Called from KUIP                                                     *
*                                                                      *
* Arguments:                                                           *
* name       in/out/update Argument description                        *
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/PTGE.fi"

      CHARACTER*78 COPT

      INTEGER      LENOCC,L
      EXTERNAL     LENOCC  

#include "arte/Arte.ff" 
#include "auto/PTGE.ff"

      COPT='FILE'
      CALL KUGETC( COPT     , L )
      IF( L .LE. 0 )COPT='FILE'  

      L = LENOCC(COPT) 

      IF(COPT(1:1) .NE. 'F' )THEN 
       C78='PTLREA warning! only COPT='
       CALL CH78AC('FILE' )
       CALL CH78BC( 'is currently allowed!' ) 
       CALL ME78WC( 9128347  ) 
       COPT='FILE' 
      ENDIF 
 
       
      IF( JPTGE .NE. 0 )THEN
       C78='PTLREA warning! existing PTGE table will be removed!' 
       CALL ME78WC( 912874  ) 
       CALL MMDROP( JPTGE ) 
      ENDIF 

      CALL PTLDAT

      RETURN 
      END 



