
      SUBROUTINE RICDAT

************************************************************************
*
* written by Siegmund Nowak, 16/03/95 09.18.12
*
* External references: IO..., FF..., ...KEY,
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"

      INTEGER MXBUF 
      parameter(mxbuf=2000)
      character*4 chrich(mxbuf)
      logical*1 ricbuf(4*mxbuf)
      equivalence(chrich,ricbuf)

      integer bufsize,ib
      common/cricbuf/bufsize,ib,ricbuf

      INTEGER IOS, LENOCC
      CHARACTER CFILE*12, CNAME*120, SUBDIR*80, VERS*20
      LOGICAL EXS

#include "arte/Arte.ff"

C---             Initialize geo dat input

      CFILE = 'rich.dat'
      CALL IOCLOS (LREAD)
      CNAME = CFILE(1:LENOCC(CFILE))
      INQUIRE(FILE=CNAME(1:LENOCC(CNAME)),EXIST=exs,IOSTAT=IOS)
      IF(EXS) THEN
         CALL MEWARN ('file ' //CNAME(1:LENOCC(CNAME))// 
     +                ' is taken from your home directory')
         GO TO 1
      ENDIF

      CALL GETENVF('RICH_CONFIGDIR',SUBDIR)
      IF(LENOCC(SUBDIR).LE.0) GO TO 2 
      CNAME = SUBDIR(1:LENOCC(SUBDIR)) // '/'// CNAME(1:LENOCC(CNAME))
      INQUIRE(FILE=CNAME(1:LENOCC(CNAME)),EXIST=exs,IOSTAT=IOS)
      IF(EXS) THEN
         CALL MEWARN ('file ' //CNAME(1:LENOCC(CNAME))// 
     +                ' is taken from RICH_CONFIGDIR' )
         GO TO 1
      ENDIF

 2    CALL GETENVF('HB',SUBDIR)
      CALL GETENVF('HBVERS',VERS) 
      SUBDIR = SUBDIR(1:LENOCC(SUBDIR))//'/'//VERS(1:LENOCC(VERS))
      CNAME = SUBDIR(1:LENOCC(SUBDIR)) // '/geo/rich/' //
     +                               CNAME(1:LENOCC(CNAME))
      INQUIRE(FILE=CNAME(1:LENOCC(CNAME)),EXIST=exs,IOSTAT=IOS)
      IF(EXS) GO TO 1 

      CALL MEWARN( 'no file '//CFILE(1:LENOCC(CFILE))//' is found')
      GO TO 999

 1    CALL IOCONC (LREAD, CNAME(1:LENOCC(CNAME)), ' ', 0)
      CALL IOOPEN (LREAD, 'FO', 0, IOS)
      CALL FFINIT(0)

      bufsize=4*mxbuf
      ib=0
      call ffkey('RICH',chrich,mxbuf,'MIXED')

C     Read in  data cards
      CALL FFSET('LINP',LREAD)
      CALL FFSET('LOUT',LLOGF)
      CALL FFGO
      CALL IOCLOS(LREAD)


 999  RETURN
      END

************************   END    RICDAT    *****************************
