/*
************************************************************************
*
* SZH3_ARTE
* written by Siegmund Nowak
*
* This routines allows changes in the automatically produced NEDE/NWAL
* banks for the rich 
*
*       called from G..MAIN
*
* The transferred parameters are
* void szh3_arte_(int ncal,int nwal,char lvols[],int lcopy[],int nlev)  
************************************************************************
*/

#include <stdio.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/gclink.h"
#include "gean/zgeom.h"


void szh3_arte(int ncal,int ,char lvols[],int lcopy[],int nlev) {

    zgvol ZGVOL;
    union { int ji; float jx;};
    
    if(ncal) {  

      int Gvolnum = ZGVOL.Check_Gvol(&lvols[4*nlev-4]);
      int jvos = *(gcbank_.lq + gclink_.jvolum -1 - Gvolnum);
      ji =*(gcbank_.iq + jvos + 2);
      int nin = int(jx);
      for(int in = 1; in <= nin;in++) {
          int jin = *(gcbank_.lq + jvos -1 -in);
          ji = *(gcbank_.iq + jin +2);
          int iuser = int(jx);
          if(iuser == lcopy[nlev]){
	    jx = float(ncal);
            *(gcbank_.iq + jin +2) = ji;
            return;}}
      arteMsg << "szh3_arte: copy not found -contact S.Nowak ";
      arteMsg.error();        
}}          

/* szh3_arte_ */









