*-- Author :    Thomas Lohse   August 24, 1999

      SUBROUTINE KAMCUT

************************************************************************
*
* Description: PRETRIG/CUT/MUON (KUIP command)
*              activate a pretrigger window for muons
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/luopts.fi"

      integer message_id_1
      save message_id_1

      if (nmuacc.eq.20) then
        call MEERRC (message_id_1, 
     +          'KAMCUT: too many pretrigger windows activated')
        goto 90
      endif

      nmuacc = nmuacc + 1
      call KUGETR(ptlcut(nmuacc,2))
      ptlcut(nmuacc,2) = ptlcut(nmuacc,2)**2
      call KUGETR(txmin(nmuacc,2))
      call KUGETR(tymin(nmuacc,2))
      call KUGETR(txmax(nmuacc,2))
      call KUGETR(tymax(nmuacc,2))

 90   END

************************************************************************
* End of KAMCUT
************************************************************************
