*CMZ :          05/09/96  20.35.12  by  Fedor Ratnikov
*-- Author :    Fedor Ratnikov   27/04/96
************************************************************************
*
* L1CPMTR
* written by Fedor Ratnikov, 27/04/96 16.33.27
*
* This routines action: Extracts MTRA references for given digit
* and copies it to given relation bank
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* ix          in        Zebra store division
* idig        in        ARTE digit number
* jl1_mtra    --        bank keeping relations to MTRA
* il1         in        L1 bank row to be refered
************************************************************************
c
      SUBROUTINE L1CPMTR(ix,idig,jl1_mtra,il1)
c
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"
      INTEGER ix,idig,jl1_mtra,il1
      INTEGER jAux,MIMP,MTRA
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
#include "l1si/ydef.ff"
c
      jAux = I_1(idig,JMIDI)
      DO WHILE (jAux.gt.0 )     ! while there are ``from'' relations
       MIMP = K_1(jAux,JMIDI)
       MTRA = OMIMP_MTRA(MIMP)
       CALL l1exrel(ix,jl1_mtra,il1,MTRA) ! establish new ``To''
                                          ! relation
       jAux = N_1(jAux,JMIDI)
      ENDDO
      RETURN
c
      END
