*CMZ :          05/09/96  20.38.01  by  Fedor Ratnikov
*CMZ :  1.00/01 06/06/95  15.22.49  by  Dominik Ressing
*CMZ :  1.00/00 29/01/95  21.44.46  by  Fedor Ratnikov
*-- Author :    Dominik Ressing   08/12/94
************************************************************************
*
* L1USRMD
* written by Dominik Ressing, 08/12/94 08.36.07
*
* This routines action:
* User actions before message deletion: called from l1mesde,l1messc
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* Lmess        in         pointer to message
*
*
************************************************************************
c
      SUBROUTINE L1USRMD(Lmess)
c
      IMPLICIT NONE
c
#include "arte/Arte.fi"
#include "l1si/ydef.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1user.fi"
#include "l1si/l1clink.fi"
#include "l1si/rchead.fi"
#include "l1si/rcfdef.fi"
#include "l1si/l1banks.fi"
c
      INTEGER Lmess,iBX,itrk,Jpo
      LOGICAL HEXIST
c
#include "arte/Arte.ff"
#include "l1si/ydef.ff"
#include "l1si/rcfunc.ff"
c
cc... photon search
c
      CALL L1GAMPR(Lmess)
c
c
      iBX = L1MESTOR(Lmess+L1MEprbx)
c
      IF(HEXIST(L1MESTUPnr))   THEN
         L1MESTUiBX     = iRCEvent
         L1MESTUDeadPo  = L1MEstor(Lmess+L1MElast)
         L1MESTUBirthPo = L1MEstor(Lmess+L1MEcreated)
         L1MESTUPreType = L1MEstor(Lmess+L1MEprid)
         T1MESTUPreX    = T1MEstor(Lmess+L1POlcog+L1GEOINFx0)
     &        + T1MEstor(Lmess+L1POlcog+L1GEOINFsx)/2.
         T1MESTUPreY    = T1MEstor(Lmess+L1POlcog+L1GEOINFy0)
     &        + T1MEstor(Lmess+L1POlcog+L1GEOINFsy)/2.
         T1MESTUPreDX   = T1MEstor(Lmess+L1POlcog+L1GEOINFsx)/2.
         T1MESTUPreDY   = T1MEstor(Lmess+L1POlcog+L1GEOINFsy)/2.
         T1MESTUPreThre = T1MEstor(Lmess+L1MEprth)
         T1MESTUPreEmes = T1MEstor(Lmess+L1MEpren)
         T1MESTUFxCOG   = MIN(T1MEstor(Lmess+L1POlcogFactorX),4.)
         T1MESTUFyCOG   = MIN(T1MEstor(Lmess+L1POlcogFactorY),4.)
         T1MESTUP       = T1MEstor(Lmess+L1MEp)
         T1MESTUPx      = T1MEstor(Lmess+L1MEpx)
         T1MESTUPy      = T1MEstor(Lmess+L1MEpy)
         T1MESTUPz      = T1MEstor(Lmess+L1MEpz)
         IF ( L1MEstor(Lmess+L1MEcharge).ge.0. ) THEN
            T1MESTUBremThCorret = T1MEstor(Lmess+L1MEbremPlusTh)
            T1MESTUBremThWrong  = T1MEstor(Lmess+L1MEbremMinusTh)
         ELSE
            T1MESTUBremThCorret = T1MEstor(Lmess+L1MEbremMinusTh)
            T1MESTUBremThWrong  = T1MEstor(Lmess+L1MEbremPlusTh)
         END IF
         T1MESTUBremRat      = T1MEstor(Lmess+L1MEBremRatio)
         T1MESTUDiffTRK = T1MEstor(Lmess+L1MEtrkDP)
         itrk = L1MEstor(Lmess+L1MEtrktrk)
         CALL l1getrx(itrk,Jpo)
         IF ( Jpo.le.0 ) THEN
            L1MESTUTRKflag = -1
            L1MESTUTRKid   = 0
         ELSE
            L1MESTUTRKflag = IQ(Jpo+L1_TRK_FLAG)
            L1MESTUTRKid   = I_V(6,itrk,JMTRA)
         END IF
c
         CALL HFNT(L1MESTUPnr)
      ENDIF
c
      IF (L1MEstor(Lmess+L1MElast).ge.4 )
     &     L1EVMAXNtpm(iBX)  = L1EVMAXNtpm(iBX)  + 1
      L1EVMAXNmess(iBX) = L1EVMAXNmess(iBX) + 1
c
      RETURN
c
      END


