*CMZ :  2.01/01 21/11/95  14.22.46  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   15/09/95

      SUBROUTINE KALMCT

************************************************************************
*
* Description: KUIP LMCTRUTH command: List MTRA and MVER
*
* Called from: KUIP
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MTRA.fi"

      INTEGER I, L, K, TPNAM1
      CHARACTER CNAME*12, CTPL*3

#include "arte/Arte.ff"
#include "auto/MTRA.ff"

      CALL UTKUGC (0, I, CNAME, L)
      CALL KUGETC (CTPL, K)

      IF (L .EQ. 0)  THEN
        CALL LIMCTR (I, CTPL)
      ELSE
        I = TPNAM1 (CNAME)
        IF (I .EQ. 0)  THEN
          CALL MEWARC (2314561, 'LMCTRUTH: unknown particle name')
        ELSE
          DO 10 L = 1, NMTRA()
            IF (OMTRA_TOPP(L) .EQ. I)  CALL LIMCTR (L, CTPL)
 10       CONTINUE
        END IF
      END IF

      END

************************************************************************
* End of KALMCT
************************************************************************
