
* B.Fominykh  23.05.99
* the routine of the MUREC-B package
* managing the tree grouth for one seed
*
      SUBROUTINE MURTRG(ISTAR,IDEBPR)
C     ===============================
* input: ISTAR - start branch containing the seed
* input: IDEBPR >0 - debug print
* output:IFREE - first free branch from /MUCTAB/
      IMPLICIT NONE
      INTEGER ISTAR,IRL,MUSL,MBRACT,ICRASH,IBRMX
      INTEGER IHT,JHT,IHTR,IOUT,JW,I,J,IBR,IBRU,JBR
      INTEGER JSTR,JNBR,LAY,IJ,IDEBPR
      INTEGER IH,IHT1,IHT2,ICLS2
      INTEGER ISD,JSD,IVICT
      REAL ZR,Z,SIGP,XREX,YREX,DD,CHI,SINR,COSR,DSD,YSD
      REAL SMS,SIGS,CHIP,SIGX,SIGY,CHIX,CHIY,CHI1,CHI2
      REAL DUMMY
#include "murec/MUCBPAR.fi"
#include "murec/MUCBTAB.fi"
#include "murec/MUCBZDT.fi"
#include "murec/MUCKALF.fi"
* preliminary selection storage for one reco layer
      INTEGER IOBRHT(NMHMXP)
      INTEGER MTBRW,MTBRP,MTBRX,MTBRMX
      PARAMETER (MTBRMX=20)
      INTEGER MTBRHW(MTBRMX)
      REAL DDBRHW(MTBRMX),DBRHW(MTBRMX)
      INTEGER MTBRHP(MTBRMX)
      REAL DXBRHP(MTBRMX),XBRHP(MTBRMX),DYBRHP(MTBRMX),YBRHP(MTBRMX)
      INTEGER MTBRHX(MTBRMX)
      REAL DXBRHX(MTBRMX),XBRHX(MTBRMX),DYBRHX(MTBRMX),YBRHX(MTBRMX)
      DOUBLE PRECISION PARMM(5),COVM(4,4)
      DOUBLE PRECISION SX,SY,SX2,SY2,HX(4),HY(4)
*
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      IFREE=ISTAR
      ICRASH=0
      MUSL=0
* loops over reconstruction layers
      DO 170 IRL=1,NMRLAY
        IF(NMUACL(IRL).LT.1) GOTO 170      ! no active clusters - nothing to do
* analysis of work in previous muon superlayer
        IF(MUSL.GT.0.AND.MUSL.NE.MUSLDT(IRL)) THEN
          IF(IFREE.EQ.ISTAR) GOTO 200      ! no hits were linked
* kill not active branches
          MBRACT=0
          DO 10 IBR=ISTAR,IFREE-1
            JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2
* selection of victim
            IVICT=1
       IF(MUSL.EQ.1.AND.
     + IQ(JBR+9)+IQ(JBR+10)+IQ(JBR+11).GE.NHTMN1) IVICT=0
       IF(MUSL.EQ.1.AND.
     + IQ(JBR+12).GE.NHTMN2) IVICT=0
       IF(MUSL.EQ.2.AND.
     + IQ(JBR+13)+IQ(JBR+14)+IQ(JBR+15).GE.NHTMN1) IVICT=0
       IF(MUSL.EQ.2.AND.
     + IQ(JBR+16).GE.NHTMN2) IVICT=0
       IF(MUSL.EQ.3.AND.
     + IQ(JBR+17).GE.NHTMN3) IVICT=0
       IF(MUSL.EQ.3.AND.
     + IQ(JBR+18).GE.NHTMN2) IVICT=0
       IF(MUSL.EQ.4.AND.
     + IQ(JBR+19).GE.NHTMN3) IVICT=0
       IF(MUSL.EQ.4.AND.
     + IQ(JBR+20).GE.NHTMN2) IVICT=0
            IF(IVICT.EQ.1) THEN
              IQ(JBR+1)=0
            ENDIF
            MBRACT=MBRACT+1-IVICT
            ICRASH=ICRASH+MBRACT
            IQ(JBR+6)=0
*
  10      CONTINUE
* total crash of seed
          IF(ICRASH.EQ.0) THEN
            IFREE=ISTAR
            GOTO 200
          ENDIF
* stop if there are no active branches
          IF(MBRACT.EQ.0) GOTO 200
        ENDIF
        MUSL=MUSLDT(IRL)
* Z for preselection
        ZR  =0.5*(ZMUDT1(IRL)+ZMUDT2(IRL))
* loops over branchs
* seed without hits works only in the layer where it gets first hit
        IBRMX=IFREE
        IF(IFREE.GT.ISTAR) THEN
          IBRMX=IFREE-1
        ENDIF
        DO 140 IBR=ISTAR,IBRMX
          JBR=JTMP7+IQ(JTMP7+1)*(IBR-1)+2
* is the branch dead?
          IF(IQ(JBR+1).EQ.0) GOTO 140
* pointer to seed
          ISD=IQ(JBR+4)
          JSD=JTMP6+IQ(JTMP6+1)*(ISD-1)+2
* multiple scattering error
          IF(MUSL.EQ.1) THEN
            SIGP=Q(JSD+26)
          ELSE
            SIGP=Q(JSD+2*MUSL+23)
          ENDIF
* extrapolation of seed to ZR
          XREX=Q(JBR+26)*(ZR-Q(JBR+23))+Q(JBR+24)
          YREX=Q(JBR+27)*(ZR-Q(JBR+23))+Q(JBR+25)
          DO I=1,5
            PARAM(I)=Q(JBR+22+I)
            PARMM(I)=PARAM(I)
          ENDDO
          DO I=1,4
            DO J=1,4
              IJ=4*(I-1)+J
              COV(I,J)=Q(JBR+27+IJ)
              COVM(I,J)=COV(I,J)
            ENDDO
          ENDDO
* projection matrix
          HX(1)=1.
          HX(2)=0.
          HX(3)=ZR-PARAM(1)
          HX(4)=0.

          HY(1)=0.
          HY(2)=1.
          HY(3)=0.
          HY(4)=ZR-PARAM(1)
* error of extrapolation
          SX2=0.
          DO I=1,4
          DO J=1,4
            SX2=SX2+HX(I)*COV(I,J)*HX(J)
          ENDDO
          ENDDO
          IF(SX2.LT.0.) GOTO 140

          SY2=0.
          DO I=1,4
          DO J=1,4
            SY2=SY2+HY(I)*COV(I,J)*HY(J)
          ENDDO
          ENDDO
          IF(SY2.LT.0.) GOTO 140

          IF(SX2.GT.1.E-8) THEN
            SX=DSQRT(SX2)
          ELSE
            SX=0.
          ENDIF
          IF(SY2.GT.1.E-8) THEN
            SY=DSQRT(SY2)
          ELSE
            SY=0.
          ENDIF

      IF(IDEBPR.GT.0) THEN
      WRITE(LLOGF,1400) ISD,ZR,XREX,YREX,SX2,SX,SY2,SY
 1400 FORMAT(2X,'seed ',I3,' extr z= ',F7.1,' X,Y ',2F7.2,
     +       ' SX2,SX ',2E12.4,' SY2,SY ',2E12.4)
      ENDIF

* 1st step: preliminary selection of reco layer clusters
          MTBRW=0
          MTBRP=0
          MTBRX=0
          IHT1=JCLPT1(IRL)
          IHT2=JCLPT1(IRL)+NMUCLL(IRL)-1

      IF(IDEBPR.GT.0) THEN
      WRITE(LLOGF,1405) IRL,IHT1,IHT2,JCLPT1(IRL),NMUCLL(IRL)
 1405 FORMAT(2X,'IRL ',I3,' IHT1,IHT2 ',2I4,' JC/NM ',2I4)
      ENDIF

*
          DO 50 IHT=IHT1,IHT2
            IOBRHT(IHT)=0
            JHT=JTMP8+IQ(JTMP8+1)*(IHT-1)+2
* not use the killed clusters
            IF(IQ(JHT+1).EQ.0) GOTO 50
* hit type
            IHTR=IQ(JHT+5)
            LAY =IQ(JHT+4)
* preselection in the case of wire
            IF(IHTR.EQ.1) THEN

              SINR=Q(JHT+7)
              COSR=SQRT(1.-SINR*SINR)
              DSD=XREX*COSR-YREX*SINR
              YSD=XREX*SINR+YREX*COSR
              SMS=Q(JHT+11)**2
              SIGS=SIGP*SIGP+SMS+SESX+SX2
              CHIP=(Q(JHT+8)-DSD)**2/SIGS

      IF(IDEBPR.GT.0) THEN
      WRITE(LLOGF,1401) MUSL,IRL,IBR,IHT,SIGS,CHIP
 1401 FORMAT(2X,' MUSL,IRL,IBR,ICL,SIGS,CHIP',4I5,2E12.4)
      ENDIF

* 1st check-point
              IF(CHIP.GT.CCUTR) GOTO 50


      IF(IDEBPR.GT.0) THEN
      WRITE(LLOGF,1402) YSD,Q(JHT+9),Q(JHT+10),SY
 1402 FORMAT(10X,' YSD,Ywire1,Ywire2',3E12.4,' SY ',E12.4)
      ENDIF

* 2nd check-point
              IF(YSD.LT.Q(JHT+9)-DYSURE-3.*SY)  GOTO 50
              IF(YSD.GT.Q(JHT+10)+DYSURE+3.*SY) GOTO 50

* save the wire cluster
              IF(MTBRW.GE.MTBRMX) GOTO 51
              MTBRW=MTBRW+1
              IOBRHT(IHT)=MTBRW
              MTBRHW(MTBRW)=IHT
              DDBRHW(MTBRW)=Q(JHT+8)-DSD
              DBRHW(MTBRW) =Q(JHT+8)
            ENDIF
* preselection in the case of pads and pixels
            IF(IHTR.NE.2.AND.IHTR.NE.3) GOTO 50
            SMS= Q(JHT+11)**2
            SIGX=SIGP*SIGP+SMS+SESX+SX2
            CHIX=(Q(JHT+8)-XREX)**2/SIGX
            SMS= Q(JHT+12)**2
            SIGY=SIGP*SIGP+SMS+SESY+SY2
            CHIY=(Q(JHT+9)-YREX)**2/SIGY

      IF(IDEBPR.GT.0) THEN
      WRITE(LLOGF,1501) MUSL,IRL,IBR,IHT,SIGX,CHIX,SIGY,CHIY
 1501 FORMAT(2X,' MUSL,IRL,IBR,IHT',4I5,
     +         ' SIGX,CHIX,SIGY,CHIY',4E12.4)
      ENDIF

* check-points
            IF(CHIX.GT.CCUTR) GOTO 50
            IF(CHIY.GT.CCUTR) GOTO 50

* save the pad
            IF(IHTR.EQ.2) THEN
              IF(MTBRP.GE.MTBRMX) GOTO 51
              MTBRP=MTBRP+1
              IOBRHT(IHT)=MTBRP
              MTBRHP(MTBRP)=IHT
              DXBRHP(MTBRP)=Q(JHT+8)-XREX
              XBRHP(MTBRP) =Q(JHT+8)
              DYBRHP(MTBRP)=Q(JHT+9)-YREX
              YBRHP(MTBRP) =Q(JHT+9)
            ENDIF
* save the pixel
            IF(IHTR.EQ.3) THEN
              IF(MTBRX.GE.MTBRMX) GOTO 51
              MTBRX=MTBRX+1
              IOBRHT(IHT)=MTBRX
              MTBRHX(MTBRX)=IHT
              DXBRHX(MTBRX)=Q(JHT+8)-XREX
              XBRHX(MTBRX) =Q(JHT+8)
              DYBRHX(MTBRX)=Q(JHT+9)-YREX
              YBRHX(MTBRX) =Q(JHT+9)
            ENDIF
 50       CONTINUE
 51       CONTINUE
*
* no active clusters
         IF(MTBRW.LE.0.AND.MTBRP.LE.0.AND.MTBRX.LE.0) GOTO 140

* debug output
      IF(IDEBPR.GT.0) THEN
      WRITE(LLOGF,1101) MUSL,IRL,IBR,MTBRW,MTBRP,MTBRX,
     + SIGS,SIGX,SIGY
 1101 FORMAT(2X,'MUSL,IRL,IBR',3I4,' prel clust:',3I4,
     +         ' sig2: ',3E12.4)
      IF(MTBRW.GT.0) THEN
        WRITE(LLOGF,1102) (MTBRHW(I),I=1,MTBRW)
 1102 FORMAT(5X,'wire clust:', 10I7)
        WRITE(LLOGF,1103) (DDBRHW(I),I=1,MTBRW)
 1103 FORMAT(5X,'residuals:', 10F7.1)
      ENDIF
      IF(MTBRP.GT.0) THEN
        WRITE(LLOGF,1104) (MTBRHP(I),I=1,MTBRP)
 1104 FORMAT(5X,'pad clust:', 10I7)
        WRITE(LLOGF,1105) (DXBRHP(I),I=1,MTBRP)
 1105 FORMAT(7X,'X-resid:', 10F7.1)
        WRITE(LLOGF,1106) (DYBRHP(I),I=1,MTBRP)
 1106 FORMAT(7X,'Y-resid:', 10F7.1)
      ENDIF
      IF(MTBRX.GT.0) THEN
        WRITE(LLOGF,1107) (MTBRHX(I),I=1,MTBRX)
 1107 FORMAT(5X,'pix clust:', 10I7)
        WRITE(LLOGF,1105) (DXBRHX(I),I=1,MTBRX)
        WRITE(LLOGF,1106) (DYBRHX(I),I=1,MTBRX)
      ENDIF
      ENDIF


* Kalman filtering
          ICLS2=0
          DO 100 IHT=IHT1,IHT2
* take only preliminary selected clusters
            IH= IOBRHT(IHT)
            IF(IH.LT.1) GOTO 100
            JHT=JTMP8+IQ(JTMP8+1)*(IHT-1)+2
* hit type
            IHTR=IQ(JHT+5)
* muon superlayer
            MUSLKF=IQ(JHT+3)
* Kalman filtering in the case of wire
            IF(IHTR.EQ.1) THEN
              DO I=1,5
               PARAM(I)=PARMM(I)
              ENDDO
              DO I=1,4
               DO J=1,4
                COV(I,J)=COVM(I,J)
               ENDDO
              ENDDO
              IF(MUSL.EQ.1) THEN
                SIGMS1=Q(JSD+26)
                SIGMS2=SIGMS1
              ELSE
                SIGMS1=Q(JSD+2*MUSL+24)
                SIGMS2=Q(JSD+2*MUSL+23)
              ENDIF
              Z=Q(JHT+6)
              ZMEAS=Z
              SINROT=Q(JHT+7)
              COSROT=SQRT(1.-SINROT*SINROT)
              DMEAS=Q(JHT+8)
              SMEAS=Q(JHT+11)
              ITMEAS=1
              IF(Q(JHT+7).NE.0.) ITMEAS=3
* check-point (PRECISE CONTROL)
              CALL MURKALFB(IDEBPR,0,IOUT,DD,CHI)
      IF(IDEBPR.GT.0)
     + WRITE(LLOGF,*) 'cl,dd,chi,IOUT',
     +                 IHT,DD,CHI,IOUT
              IF(IOUT.NE.0) GOTO 100
              GOTO 20
            ENDIF
*
* Kalman filtering in the case of pads and pixels
            IF(IHTR.EQ.2.OR.IHTR.EQ.3) THEN
              DO I=1,5
               PARAM(I)=PARMM(I)
              ENDDO
              DO I=1,4
               DO J=1,4
                COV(I,J)=COVM(I,J)
               ENDDO
              ENDDO
              IF(MUSL.EQ.1) THEN
                SIGMS1=Q(JSD+26)
                SIGMS2=SIGMS1
              ELSE
                SIGMS1=Q(JSD+2*MUSL+24)
                SIGMS2=Q(JSD+2*MUSL+23)
              ENDIF
              Z=Q(JHT+6)
              SINROT=0.
              ZMEAS=Z
              COSROT=1.
              DMEAS=Q(JHT+8)
              SMEAS=Q(JHT+11)
              ITMEAS=1
* check-point (PRECISE CONTROL)
              CALL MURKALFB(IDEBPR,0,IOUT,DUMMY,CHI1)
              IF(IOUT.NE.0) GOTO 100
*
              DMEAS=Q(JHT+9)
              SMEAS=Q(JHT+12)
              ITMEAS=2
* 3th check-point (PRECISE CONTROL)
              CALL MURKALFB(IDEBPR,0,IOUT,DUMMY,CHI2)
              IF(IOUT.NE.0) GOTO 100
              CHI=CHI1+CHI2
              DD=0.
              GOTO 20
            ENDIF
            GOTO 100
*
* hit was linked
  20        CONTINUE

            IF(IDEBPR.GT.0) WRITE(LLOGF,*) '  accepted cluster', IHT

* total crash of seed in the case of NHMUTR+1 cluster (crazy check for sure)
            IF(IQ(JBR+8).GE.NHMUTR) THEN
              IFREE=ISTAR
              GOTO 200
            ENDIF
*
            IBRU=IBR  ! branch to be updated
* is it necessary to create a new branch?
            JSTR=JTMP7+IQ(JTMP7+1)*(ISTAR-1)+2
* create new branch in the case of reco layers 1-8
*    and only if it's a first accepted cluster
      IF(IRL.GT.0.AND.IRL.LE.8.AND.IQ(JBR+8).EQ.0) THEN
        IF(IFREE.EQ.IBR) IFREE=IFREE+1
        GOTO 30
      ENDIF
* the case of other reco layers:
* not create a new branch if it's a first cluster in reco layer
            IF(ICLS2.EQ.0) GOTO 40
* create new branch
  30        CONTINUE
* compear the number of branchs with the number of rows in a table
            IF(IFREE.LE.IQ(JTMP7+2)) GOTO 32
            CALL MMBOOK(JTMP7,1)
            GOTO 30
  32        JBR =JTMP7+IQ(JTMP7+1)*(IBR-1)+2
            JNBR=JTMP7+IQ(JTMP7+1)*(IFREE-1)+2
* copy old branch to new one
            DO I=1,IQ(JTMP7+1)
              IQ(JNBR+I)=IQ(JBR+I)
            ENDDO
            IQ(JNBR+2)=IBR         ! link to mother branch
* correct number of accepted clusters and last common cluster
            IQ(JNBR+3)=0
            IQ(JNBR+8)=0
            IF(IQ(JBR+8).GT.0) THEN
              IQ(JNBR+3)=IQ(JBR+8)-1
              IQ(JNBR+8)=IQ(JBR+8)-1
* correct hit map
      IF(MUSL.LT.4) IQ(JNBR+4*MUSL+LAY+4)=IQ(JBR+4*MUSL+LAY+4)-1
      IF(MUSL.EQ.4) IQ(JNBR+LAY+18)=IQ(JBR+LAY+18)-1
            ENDIF
* add first cluster to old branch but add the nexts to new one
            IF(ICLS2.EQ.1) IBRU=IFREE
            IFREE=IFREE+1
            IF(IFREE.GT.NBMUTR) GOTO 200

      IF(IDEBPR.GT.0) WRITE(LLOGF,1012)
     +         ISTAR,IRL,MUSL,IBR,IQ(JTMP7+2),IFREE
 1012 FORMAT(2X,'new branch created, ISTAR,IRL,MUSL,IBR,NB,IFREE:',6I5)

* update the branch
  40        ICLS2=1
            JBR =JTMP7+IQ(JTMP7+1)*(IBRU-1)+2
            IQ(JBR+6)=IQ(JBR+6)+1  ! +1 cluster to counter
            IQ(JBR+8)=IQ(JBR+8)+1  ! +1 cluster to branch

      IF(IDEBPR.GT.0) WRITE(LLOGF,1013)
     +         ISTAR,IRL,MUSL,IBRU,IQ(JTMP7+2),IFREE
 1013 FORMAT(2X,'update the branch, ISTAR,IRL,MUSL,IBRU,NB,IFREE:',6I5)

* hit map
      IF(MUSL.LT.4) IQ(JBR+4*MUSL+LAY+4)=IQ(JBR+4*MUSL+LAY+4)+1
      IF(MUSL.EQ.4) IQ(JBR+LAY+18)=IQ(JBR+LAY+18)+1
* update parameters and covariance
            DO I=1,5
              Q(JBR+22+I)=PARAM(I)
            ENDDO
            DO I=1,4
            DO J=1,4
              IJ=4*(I-1)+J
              Q(JBR+27+IJ)=COV(I,J)
            ENDDO
            ENDDO
* pointers to clusters
            JW=JBR+LCMUTR+IQ(JBR+8)
            IQ(JW) =IHT
            Q(JW+NHMUTR)=DD
            Q(JW+2*NHMUTR)=CHI
* wire residuals and chi**2
            Q(JBR+21)=Q(JBR+21)+DD  ! sum of wire residuals squared
            Q(JBR+22)=Q(JBR+22)+CHI ! sum chi**2

      IF(IDEBPR.GT.0) WRITE(LLOGF,1014) IBRU,IHT,DD,CHI
 1014 FORMAT(2X,'branch',I3,' updated with clust',I3,' DD,CHI',2E12.4)

*
  100     CONTINUE
*
  140   CONTINUE
*
  170 CONTINUE
*
  200 CONTINUE
      RETURN
      END






