*
* B.Fominykh  17.06.98
* the program of MUREC-B package
* tests the quolity of reconstructed track
* input:  NT    - branch number
* output: IQUAL - =0 track accepted, <0 track rejected
*         RQUAL - parameter
*
      SUBROUTINE MURTTRB(NT,IQUAL,RQUAL)
*     =================================
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "murec/MUCBTAB.fi"
      INTEGER IQUAL,NT,JT,I,J,ICC,IC,JC,MUSL,LAY,RLAY,ITYPE
      INTEGER HITMAP(4,4),RCL(38)
      REAL DD,D(38),RQUAL
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
      IQUAL=-1
      IF(NT.LE.0.OR.NT.GT.IQ(JTMP7+2)) GOTO 999
      JT=JTMP7+IQ(JTMP7+1)*(NT-1)+2
* number of accepted hits
      IF(IQ(JT+8).LT.4) GOTO 999
* track parameters Tx,Ty control
      IF(ABS(Q(JT+26)).GT.10.) GOTO 999
      IF(ABS(Q(JT+27)).GT.10.) GOTO 999
*
      DO I=1,38
        RCL(I)=0
        D(I)  =0.
      ENDDO
      DO I=1,4
       DO J=1,4
        HITMAP(I,J)=0
       ENDDO
      ENDDO
* fill hitmap - loops over collected clusters
      DO 10 ICC=1,IQ(JT+8)
        IC=IQ(JT+LCMUTR+ICC)
        JC=JTMP8+IQ(JTMP8+1)*(IC-1)+2
        RLAY=IQ(JC+2)
        MUSL=IQ(JC+3)
        LAY =IQ(JC+4)
        ITYPE=IQ(JC+5)
        RCL(RLAY)=1
        IF(ITYPE.EQ.1) D(RLAY)=Q(JC+8)
        HITMAP(MUSL,LAY)=1
  10  CONTINUE

* number of hits
       RQUAL=3.*REAL(HITMAP(1,4))+
     +       REAL(HITMAP(1,1)+HITMAP(1,2)+HITMAP(1,3))+
     +       3.*REAL(HITMAP(2,4))+
     +       REAL(HITMAP(2,1)+HITMAP(2,2)+HITMAP(2,3))
* no hits in both shifted tube chamber planes
* MU1
       DO I=1,4
         IF(RCL(2*I-1)+RCL(2*I).EQ.1) RQUAL=RQUAL-3.
         IF(RCL(2*I-1)+RCL(2*I).EQ.2) THEN
           DD=ABS(D(2*I-1)-D(2*I))
           IF(DD.GT.2.) RQUAL=RQUAL-2.
         ENDIF
       ENDDO
* MU2
       DO I=6,8
         IF(RCL(2*I-1)+RCL(2*I).EQ.1) RQUAL=RQUAL-3.
         IF(RCL(2*I-1)+RCL(2*I).EQ.2) THEN
           DD=ABS(D(2*I-1)-D(2*I))
           IF(DD.GT.2.) RQUAL=RQUAL-2.
         ENDIF
       ENDDO
* control the hit-map
*   MU1
      IF(HITMAP(1,4).GE.1) GOTO 21
      IF(HITMAP(1,1)+HITMAP(1,2)+HITMAP(1,3)
     +                        .GE.2) GOTO 21
      GOTO 999
 21   CONTINUE
*   MU3
      IF(HITMAP(3,2).GE.1) GOTO 23
      IF(HITMAP(3,1).GE.1) GOTO 23
      GOTO 999
 23   CONTINUE
*   MU4
      IF(HITMAP(4,2).GE.1) GOTO 24
      IF(HITMAP(4,1).GE.1) GOTO 24
      GOTO 999
 24   CONTINUE
      IQUAL=0
*
 999  CONTINUE
      RETURN
      END









