#ifndef __POIROT_HIT_HH__
#define __POIROT_HIT_HH__

#ifndef __WAX_HITB_HH__
#include "wax/HITB.hh"
#endif

#ifndef __POIROT_GEDE_HH__
#include "Gede.hh"
#endif

class poirotHit : public waxHITB
{
public:
  // forward all constructors to waxHITB
  static poirotHit* Create(ArtePointer<HITB> hitb) ;
  poirotHit() : waxHITB() {} ;
  poirotHit(ArtePointer<HITB> hitb) : waxHITB(hitb) {}
  ~poirotHit() {}
  
  // inlines
  const poirotGede* GetGede() const { 
    return static_cast<const poirotGede*>(waxHITB::GetGede()) ; }
  int GetXColumn() const { return fXColumn ; }
private:
  int fXColumn ;
} ;

#endif
