#include "poirot/Hit.hh"

poirotHit* poirotHit::Create(ArtePointer<HITB> hitb)
{
  poirotHit* otrhitb=0;
  if((hitb->gede->cmp==waxGede::GetOTrComponentId())) {
    static first=true ;
    if(first && hitb->z<100) {
      cout << "Error: OTR hit before magnet !" << endl 
	   << "(This message appears only once.)" << endl
	   << "(That does not mean that there is not something really wrong.)"
	   << endl ;
      first = false ;
    } 
    
    otrhitb= new poirotHit(hitb) ;
    //     unsigned char m = otrhitb->GetWireIndex()/32 ;
    //     unsigned char c = otrhitb->GetWireIndex()%32 ;
    //     int xcol = otrhitb->GetGede()->GetWireIndexOffset() + 2*c ;
    //     if(otrhitb->GetGede()->GetXSide()==0) xcol += m ;
    //     else                                  xcol -= m ;
    //     int altxcol = int((0.1+otrhitb->GetRawX()-otrhitb->GetGede()->GetRawX(0))/
    // 		      (0.5*otrhitb->GetGede()->GetWirePitch())) ;
    //     if(otrhitb->GetRawX()-otrhitb->GetGede()->GetRawX(0) <0) altxcol-- ;
    //     if(altxcol != xcol) {
    //       cout << "poirotHit::Create(...) " 
    // 	   << hitb << " " << hitb->chid << " "
    // 	   << int(otrhitb->GetWireIndex()) << " " << int(m) << " " << int(c) << endl
    // 	   << xcol << " " << altxcol << " "
    // 	   << otrhitb->GetRawX() << " " << otrhitb->GetGede()->GetRawX(0) << " "
    // 	   << otrhitb->GetGede()->GetEPitch() << " "
    // 	   << otrhitb->GetGede()->GetWirePitch()<< endl;
    //     }
    float relx = 0.50 + otrhitb->GetRawX()/
      (0.5*otrhitb->GetGede()->GetWirePitch()) ;
    int veryaltxcol = int(relx) ;
    if(relx<0) veryaltxcol--;
    otrhitb->fXColumn = veryaltxcol ;
  }
  return otrhitb ;
}

