// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#ifndef RANGER_SEED_TABLEAU
#define RANGER_SEED_TABLEAU

#include <vector.h>

class rangerDomain;
class rangerSeedSet;

class rangerSeedTableau {

public:
  rangerSeedTableau(){};
  rangerSeedTableau(rangerDomain* dom,int direction);
  ~rangerSeedTableau(){};

  vector<rangerSeedSet*>& seedSets() { return sss;};
  void appSeedSet(rangerSeedSet* ss) { if (ss) sss.push_back(ss); };
  int direction() { return direct;};
  void dump(const int level=1);

private:
  
  rangerDomain* domain;
  int direct;
  vector<rangerSeedSet*> sss;

};
#endif
