// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerVolCone
// volume class for cone shape

#ifndef rangerVolCone_HH
#define rangerVolCone_HH

#include "rang/Volume.hh"
#include "rang/GeWa.hh"

class rangerVolCone : public rangerVolume {

public:
  rangerVolCone(); // default constructor
  rangerVolCone( rangerGeWa* gewa ); // constructor from gewa
  ~rangerVolCone(); // destructor
  double sLength(double zz,
		 double x,
		 double y,
		 double tx,
		 double ty); // passed length

};

#endif
