// 
//  Author:  Rainer Mankel                     Created:  19-May-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/DomWin.hh"
#include "rang/Domain.hh"

extern "C" {
  void rgdomwin_(rangerDomain*& dm,
	       const int& maxWin,
	       rangerDomWin** windowVec,
	       int& nWin) {
    
    if (! dm) return;

    nWin = 0;
    for (vector <rangerDomWin*>::iterator wit=dm->win().begin();
	 wit != dm->win().end(); ++wit) {
      if (nWin < maxWin) {
	windowVec[nWin] = *wit;
	++nWin;
      }
    }
	
    return;
  }
}
	  
