// 
//  Author:  Rainer Mankel                     Created:  25-Jan-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include <iostream.h>

extern "C" {
  void tf1init_();
  void rgextini1_();
}


extern "C" {
  void rginit_() {

    // self-initialization routine of ranger

    // action occurs only in the first event

    static int init = 0;

    if (! init) {
      //cout << "rginit: ranger self-initialization" << endl;
      tf1init_();
      rgextini1_();
      init = 1;
    }
    //else {
    //  cout << "rginit: ranger is already initialized" << endl;
    //} 
  }
}
