// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/DomLay.hh"
#include "rang/DomWin.hh"

extern "C" {
  void rgwibord_(rangerDomWin*& dw,float& xmin,float& xmax,
		 float& ymin,float& ymax) {
    if (dw) {
      xmin = dw->xmin();
      xmax = dw->xmax();
      ymin = dw->ymin();
      ymax = dw->ymax();
//       cout << "rgwibord: xmin=" << xmin << " xmax=" << xmax << endl;
    }
    else {
      cout << "rgwibord: invalid dw=" << dw << endl;
    }
  }
}



    



