*-- Author :    Siegmund Nowak   17/09/93

       SUBROUTINE TFMGL(ifl,izf,npoints,entry_pt,exit_pt)

C      this sr calculates the intersection of the actual track with
C       the beginn and the end of the magnetic field

       implicit none
       real zposmg, rmag, xlmag, xrmag, hmag 
#include "rang/zf.fi"
#include "rang/zma.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"

      integer ifl, npoints, ifirst, izf, i
      real CIRCL(3,2),XENTR(5), entry_pt(3), exit_pt(3), rho, cosx, sinx
      real curv
      DATA IFIRST/0/, zposmg / 450. /, rmag / 140. /, xlmag /0./,
     +  xrmag /0./, hmag /8./
      SAVE IFIRST

#include "arte/Arte.ff"
#include "auto/GEO.ff"
C
C--   DEFINE RADIUS OF THE MAGNETIC FIELD
C
      IF(IFIRST.EQ.0) THEN
         CIRCL(1,2) = FFELD_R(1)
         CIRCL(2,2) = Ffeld_z(1)
         CIRCL(3,2) = .5 * (XLMAG + XRMAG)
         PRINT *,' MAGN ', (CIRCL(I,2),I=1,3)
         IFIRST =1
      ENDIF
c      print*,'\\',dxxxzr(1,ilev),dxxxzr(3,ilev),dzzr(ilev),ilev

      GO TO (100,200),IFL
C
C--   DEFINE ENTRY POINT INTO THE MAGNETIC FIELD
C
 100  CIRCL(1,1) = xx_zf(3,izf)
      CIRCL(2,1) = -1.
      CIRCL(3,1) = xx_zf(1,izf) - xx_zf(3,izf) * z_zf(izf)

C      PRINT *,' CIRC ', (CIRCL(I,1),I=1,3)
      CALL VXXFND(CIRCL,XENTR,1)
      IF(XENTR(1).LE..5) THEN
*        **** NO ENTRY INTO MAGNET FOR this TRACK
         npoints = 0
      ELSE
         npoints = 1
**         IF(LTSTZR) PRINT *, 'OUTP',XENTR
         entry_pt(1) = xentr(3)
         entry_pt(3) = xentr(2)
         entry_pt(2) = 0.
         exit_pt(1) = xentr(5)
         exit_pt(3) = xentr(4)
      ENDIF
      GO TO 99
C
C--   DEFINE EXIT POINT OUT OF THE MAGNETIC FIELD
C

 200  if (xx_zf(5,izf).ne.0.d0) then
       curv = (.00029975*ffeld_h(1)) * xx_zf(5,izf)
      else
       print *,' () tfmgl: izf, xx_zf(5,izf)=', izf, xx_zf(5,izf)
       curv = 1./100000.  ! sloppy fixup...
      endif
      rho = 1. / curv
      COSX = 1./DSQRT(1.D0+xx_zf(3,izf)**2)
      SINX = xx_zf(3,izf) * COSX
      CIRCL(1,1) = 1./ curv
      CIRCL(2,1) = z_zf(izf) + RHO * SINX
      CIRCL(3,1) = xx_zf(1,izf) - RHO * COSX

      CALL VXXFND(CIRCL,XENTR,0)
      IF(XENTR(1).LE..5) THEN
         npoints = 0
**         PRINT *,' tfmgl: no exit from magnet for imc= ',
**     +           imczr(ilev)
         EXIT_PT(3) = 0.
      ELSE
**         IF(LTSTZR)PRINT *, 'exit',XENTR
         I = 2
         IF(XENTR(2).GT.XENTR(4)) I = 4
         exit_pt(1) = XENTR(I+1)
         exit_pt(3) = XENTR(I)
         npoints = 1
      ENDIF
      GO TO 99

 99   RETURN
      END



