*#define RCVERT_TIME
*
*  Author :   A.Spiridonov    16/01/98
*
**************************************************************
*                                                            *
      subroutine rcvert
*                                                            *
*     Reconstuct K0s,J/psi and primary vertices,             *
*     book and fill arte table RVER in the framework         *
*     of version ARTE-01-07                                  *
*                                                            *
*     The genuine version of T.Lohse vertex package          *
*     and v0fit package was used without tuning              *
*     of parameters and modifications.                       *
*     A few routines : vtrec,vtwir,vtrini,vtpsto,            *
*     was added to use T.Lohse vertex package                *
*     in arte environment                                    *
*                                                            *
*     The user must make sure that the arte table RTRA       *
*     (reconstucted tracks) was booked and filled            *
*     ( f.e. by ranger ) before call of this routine         *
*                                                            *
**************************************************************
      implicit none
      integer flag
      real time_0,time_v0,time_prim,job_time
*=============================================================
*
#ifdef RCVERT_TIME
      call timex(time_0)
#endif
*
*                                K0s vertices
*
      call v0K0s
*
*                                J/psi vertices
*
      call v0psi
*
#ifdef RCVERT_TIME
      call timex(time_v0)
      job_time=time_v0-time_0
      print *,' CPU time for v0 vertices ', job_time,' seconds'
#endif
*
*                                primary vertices
*
      call vtrec(flag)
      call vtpsto(flag)
*
#ifdef RCVERT_TIME
      call timex(time_prim)
      job_time=time_prim-time_v0
      print *,' CPU time for primary vertices ', job_time,' seconds'
#endif
*
  999 return
      end
