*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDMENC

************************************************************************
*
* Description: make sequences from the DATT command
*
* Called from: DDEXEC
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, IS, NN, CHCMPN, LENOCC
      CHARACTER CC*200, CN*80, CH*4

#include "arte/Arte.ff"
#include "auto/DDEF.ff"


      DO 50 IS = 1, 2
        DO 40 K1 = 1, NDDEF()

          IF (IDDEF_FLAG(K1) .NE. LDDEF_MEN)  GO TO 40
          IF (HDDEF_NAME(1,K1) .EQ. HBLANKSP)  GO TO 40

          DO 10 K2 = 1, NDDUSR
            IF (IDDEF_FLAG(K2) .NE. LDDEF_TAB .AND.
     +          IDDEF_FLAG(K2) .NE. LDDEF_MEN)  GO TO 10
            IF (CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +                  IQ(HQDDEF_NAM2(1,K2))) .NE. 0)  GO TO 20
 10       CONTINUE
          GO TO 40

 20       NN = 0
          DO 30 K2 = 1, NDDEF()
              IF (IDDEF_FLAG(K2) .NE. LDDEF_TAB .AND.
     +            IDDEF_FLAG(K2) .NE. LDDEF_MEN)  GO TO 30
            IF (CHCMPN (IQ(HQDDEF_NAME(1,K1)),
     +                  IQ(HQDDEF_NAM2(1,K2))) .EQ. 0)  GO TO 30

            IF (NN .EQ. 0)  THEN
              CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CN)
              CH = 'h'
              IF (IS .EQ. 2)  CH = 'hh'
              CALL DDOPEN (CN, CH)
            END IF

            CC = '#include "auto/'
            CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CN)
            CH = '.h"'
            IF (IS .EQ. 2)  CH = '.hh"'
            CALL CHAPPC (CC, CN)
            CALL CHAPPC (CC, CH)
            WRITE (LDDEF, 1001)  CC(1:LENOCC(CC))
            NN = NN + 1
 30       CONTINUE

 40     CONTINUE
 50   CONTINUE

 1001 FORMAT (A)

      END

************************************************************************
* End of DDMENC
************************************************************************
