/**********************************************************************/
//
// $source: /afs/desy.de/group/hera-b/cxx/repository/clue/clue/RecoVertex.C,v $
// $Revision: 1.4 $
// $Author: natasha $
// $Date: 1999/08/31 10:43:04 $
//
// Created: 01-28-97,   I. Siccama, C. Borgmeier
//
// Reconstructed Vertex
//
/**********************************************************************/


#include <Clue/RecoVertex.hh>


RecoVertex::RecoVertex( ArtePointer<RVER> rver )
  : RecoTrack( rver->btra ),
    thisPoint( rver->xv, rver->yv, rver->zv ),
    flag( 0 ),
    iv( 0 )
{
  for( int i=0; i<3; ++i ) {
    for( int j=0; j<3; ++j ) {
      covMatrix[i*3+j] = rver->cv[i+j];
    }
  }
}
