
/**********************************************************************/
//
// $Source: /afs/desy.de/group/hera-b/repository/ARTE/cluearte/Wire.C,v $
// $Revision: 1.4 $
// $Author: natasha $
// $Date: 1999/08/31 10:43:05 $
//
// Created: 07-23-99,   C. Borgmeier
//
/**********************************************************************/


#include <arte/arte.hh>

#include <Clue/Wire.hh>


ClWire::ClWire( ArtePointer<GTAR> wire )
  : dz( wire->dz / sqrt(12.) )
{
  ThreeVector d( wire->dx, wire->dy, 0 );
  AtLine::operator=( AtLine( Point3D( wire->x, wire->y, wire->z ) - 0.5*d,
			     Point3D( wire->x, wire->y, wire->z ) + 0.5*d ) );
#ifdef USE_ROOT
  SetLineColor( 6 );
#endif
}
