#ifndef _GCAL_H_
#define _GCAL_H_
typedef struct {
   int ncl;
   int sec;
   float xmin;
   float xmax;
   float ymin;
   float ymax;
   float zmin;
   float zmax;
   float xmad;
   float ymad;
   float zmad;
   float eff;
   float ms;
   int cmp;
   int ogesl;
   int ogmat;
   char gvol[4];
   int fcl;
   int mim1;
   int miml;
   int dig1;
   int digl;
   int hit1;
   int hitl;
} GCAL;
#define  JGCAL (gcbank_.iq+artelink_.jgcal)
#define  NGCAL() N_U(JGCAL)
#define NCGCAL() N_C(JGCAL)
#define GCAL(i) (*((GCAL*)(JGCAL+2)+(i)-1))
#define GCAL_ogesl(i) GCAL(i).ogesl
#define GCAL_ogmat(i) GCAL(i).ogmat
#endif
