      SUBROUTINE MTLMED

************************************************************************
*
* MTLMED
* written by Siegmund Nowak 09/94
*
* This routines DEFINES MATERIAL CONSTANTS AND MEDIA FOR MSGC
*
*     +----------------------------+
*     |                            |   GLAS thickness DGL1MT
*     +----------------------------+
*     +----------------------------+   Gold thickness DAUXMT
*     |                            |
*     |                            |
*     |                            |   GAS  thickness DGASMT
*     |                            |
*     |                            |
*     |                            |
*     |                            |
*     +----------------------------+
*     |                            |   GLAS thickness DGL2MT
*     |                            |
*     +----------------------------+
*
************************************************************************

      IMPLICIT NONE

#include "gean/ZGITR.fi"

      REAL VOL_MIX(3)
      CHARACTER*12 NAM_MIX(3)

C     MSGC-Mixture
      NAM_MIX(1) = 'GLASS'
      NAM_MIX(2) = 'ITR_GAS'
      NAM_MIX(3) = 'GOLD'
      VOL_MIX(1) = DGL1MT+DGL2MT
      VOL_MIX(2) = DGASMT
      VOL_MIX(3) = DAUXMT
      CALL CRMIXT('ITR_LAYER',12,3,NAM_MIX,VOL_MIX)

      RETURN
      END


