
      SUBROUTINE PICDET
************************************************************************
* written by Siegmund Nowak
*
* This routines draws a perspective view of the whole detector
*
*       called from KUIP
************************************************************************

      IMPLICIT NONE
      INTEGER K
      CHARACTER*4 PERS,CNAME

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"

      CALL KUGETC(PERS,K)
      CALL GSATT('MOTH','LWID',-7)
      CALL GSATT('VCYL','LWID',1)
      CALL GSATT('VCYL','FILL',0)
      CALL GSATT('VCON','LWID',1)
      CALL GSATT('VCON','FILL',0)

      DO  K=1,NNESL()
      IF(INESL_CMP(K).EQ.LGESL_SIL .OR. INESL_CMP(K).EQ.LGESL_WCH .OR. 
     +   INESL_CMP(K).EQ.LGESL_MSG .OR. INESL_CMP(K).EQ.LGESL_PTC .OR.
     +   INESL_CMP(K).EQ.LGESL_MUO .OR. INESL_CMP(K).EQ.LGESL_MUX .OR. 
     +   INESL_CMP(K).EQ.LGESL_TRD .OR. INESL_CMP(K).EQ.LGESL_ECA)THEN
         CALL UHTOC(HNESL_NAME(K),4,CNAME,4)   
         CALL GSATT(CNAME,'SEEN',-2)
         CALL GSATT(CNAME,'FILL',1) 
      ENDIF
      ENDDO

      CALL GDOPT('HIDE','ON  ')
      CALL GDOPT('SHAD','ON  ')

      IF(PERS.EQ.'P') THEN
         CALL GDRAW('MOTH',75.,150.,0.,10.,10.,.008,.008)
         CALL GDRAWT(1.8,12.4,'RPOT with Si',.3,0.,2,0)
         CALL GDRAWT(4.5,7.9,'MT01-05',.3,0.,2,0)
         CALL GDRAWT(5.,14.2,'Magnet',.3,0.,2,0)
         CALL GDRAWT(5.6,13.4,'PT01-03',.3,0.,2,0)
         CALL GDRAWT(6.2,7.2,'WC06-09',.3,0.,2,0)
         CALL GDRAWT(6.8,6.6,'PC01-04',.3,0.,2,0)
         CALL GDRAWT(10.,15.0,'RICH',.3,0.,2,0)
         CALL GDRAWT(10.4,6.1,'TC01-02',.3,0.,2,0)
         CALL GDRAWT(12.8,13.,'CALO',.3,0.,2,0)
         CALL GDRAWT(13.5,4.5,'MUON System',.3,0.,2,0)
      ELSE IF(PERS.EQ.'C'.OR.PERS.EQ.'CX') THEN
         CALL GDRAW('MOTH',90.,180.,0.,10.,10.,.008,.016)
      ELSE IF(PERS.EQ.'CY') THEN
         CALL GDRAW('MOTH',90.,90.,0.,10.,10.,.008,.016)
      ENDIF

      CALL GDHEAD(1001,'HERA-B',.6)
      CALL GDSCAL(10.,2.)

      RETURN
      END

