/************************************************************************
*
* TRDMAT
* written by Siegmund Nowak
*
* This routines defines materials for TRD
*
*       called from G..MAIN
*
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteMessage.hh"
#include "arte/ArteUtil.h"
#include "gean/zgeom.h"
#include "gean/zgvers.hh"
#include "gean/ZGESL.h"

int   read_dat(FILE *,int &);
FILE  *utfilp(const char*,const char*);
extern "C" { 

  void trdmat_() {
    static char filnam[80];  static FILE *trdmat_inp;  
    zgmed ZGMED;  
    ArtePointer<NESL> sl(zgmoth_.CURRSL);   
    int cmp = sl->cmp;
   
    zgvol::Set_ind_pt(cmp);

//     select file name and  open the file
       strcpy(filnam,"TRD/trdmat.dat");         
       trdmat_inp = utfilp(filnam,"");
    
//  now the card handling begins

    for (;;)   {
//    read in one media, rotation or volume block
      int datagroup=0; int nr=0;
      datagroup = read_dat(trdmat_inp,nr); 

//    no action 
      if (datagroup == 0) continue;                          

//    media
      if (datagroup == 1 ) ZGMED.Create_Gmed(); 

      if (datagroup == -99 )  break;  
    }
  }   
}
/* trdmat_ */




