*-- Author :    Thomas Lohse   August 24, 1999

      SUBROUTINE KAECUT

************************************************************************
*
* Description: PRETRIG/CUT/ELECTRON (KUIP command)
*              activate a pretrigger window for electrons
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "arte/luopts.fi"

      integer message_id_1
      save message_id_1

      if (neacc.eq.20) then
        call MEERRC (message_id_1, 
     +          'KAECUT: too many pretrigger windows activated')
        goto 90
      endif

      neacc = neacc + 1
      call KUGETR(ptlcut(neacc,1))
      ptlcut(neacc,1) = ptlcut(neacc,1)**2
      call KUGETR(txmin(neacc,1))
      call KUGETR(tymin(neacc,1))
      call KUGETR(txmax(neacc,1))
      call KUGETR(tymax(neacc,1))

 90   END

************************************************************************
* End of KAECUT
************************************************************************
