*CMZ :          08/09/96  23.19.50  by  Fedor Ratnikov
*CMZ :  1.00/00 22/12/94  19.00.07  by  Dominik Ressing
*CMZ :  0.01/02 25/08/94  20.31.07  by  Dominik Ressing
*-- Author :    Dominik Ressing   25/08/94
************************************************************************
*
* L1HITSU
* written by Dominik Ressing, 25/08/94 19.55.40
*
* This routines action:
* store all hits from iSum and New int iSum. Identical hits are only
* stored once.
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* New        in           L1HIT pointer structure
* iSum       update       L1HIT pointer structure to sum into
*
************************************************************************
c
      SUBROUTINE L1HITSU(new,iSum)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1clink.fi"
#include "l1si/rclink.fi"
#include "gean/gcbank.fi"
#include "l1si/rcfdef.fi"
c
      INTEGER New(L1HITlen),iSum(L1HITlen)
      INTEGER nAux,iRow,nRow
c
#include "l1si/rcfunc.ff"
c
      iSum(L1HITnpo) = iSum(L1HITnpo) + 1 ! n+1 on number of allready summed up hits
c
      iRow = iSum(L1HITpos)               ! row in relation table for summed hits
      nRow = New(L1HITpos)                ! row in relation table for new hit
      IF ( iRow.eq.0 ) THEN               ! any relattions stored so far ??
         iSum(L1HITpos) = nRow               ! else -> row in relation table for new hit
      ELSE IF (nRow.gt.0) THEN            ! any relations for new hit ??
         CALL l1cprel(IXDIV,1,            ! copy relations:
     &        JL1_ME_MTRA,nRow,           ! : source row for relations
     &        JL1_ME_MTRA,iRow)           ! : add relations to this row
      END IF
c
      RETURN
c
      END





