#ifndef __POIROT_GEDE_HH__
#define __POIROT_GEDE_HH__

#ifndef __WAX_GEDE_HH__
#include "wax/Gede.hh"
#endif
#ifndef __WAX_RTRELATION_HH__
#include "wax/RTRelation.hh"
#endif

class poirotGede : public waxGede
{
public:
  // forward constructors
  poirotGede() : waxGede() {}
  ~poirotGede() {}
  float GetRMax() const { return GetRTRelation()->GetRMax() ; }
} ;

// inline int
// poirotGede::GetPRWireIndex(WireIndex_t wireNumber) const
// {
//   WireIndex_t  m = wireNumber/32;
//   WireIndex_t  c = wireNumber%32;
//   switch (GetNMonoLayers()+GetXSide())
//     {
//     case 2: return 2*GetWireIndexOffset() + 4*c + 2*m ;
//     case 3: return 2*GetWireIndexOffset() + 4*c + 2*(1-m) ;
//     case 4: return GetWireIndexOffset()   + 4*c + 2*m + m/2 ;
//     case 5: return GetWireIndexOffset()   + 4*c + 2*(4-m) + m/2 ;
//     default: ;
//     } ;
//   return 9999; //error value
// } ;


#endif
