/* The global function setup_figure_istream_menu() returns a menu for 
   creating figures.
   You should write something like:
     istream* is;
     ...
     SetupFigureBase* fig;
     setup_figure_istream_menu()(is, &fig);
     
     => *is is read, 
        if everything Ok, "new" figure is created according to what is 
	given in *is,
	"fig"  contains an address (SetupFigureBase*) of this figure
*/

// Author V.Balagura (balagura@mail.desy.de)   (24.04.98).

#ifndef _setup_figure_istream_menu_hh
#define _setup_figure_istream_menu_hh 1

#include "ptset/setup_figure.hh"
#include "ptset/istream_menu_1par.hh"

IstreamMenu_1Par<SetupFigureBase**>& setup_figure_istream_menu();

#endif
