// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerVolDummy
// dummy volume class for undefined shapes

#ifndef rangerVolDummy_HH
#define rangerVolDummy_HH

#include "rang/Volume.hh"
#include "rang/GeWa.hh"

class rangerVolDummy : public rangerVolume {
  
public:
  rangerVolDummy(); // default constructor
  rangerVolDummy( rangerGeWa* gewa ); // constructor from gewa
  ~rangerVolDummy(); // destructor
  double sLength(double z,
		 double x,
		 double y,
		 double tx,
		 double ty); // traversed length

};

#endif
