*CMZ :  4.02/00 19/07/96  13.40.04  by  Rainer Mankel
*CMZ :  4.00/02 23/09/95  15.59.32  by  Rainer Mankel
*-- Author :    Rainer Mankel   23/09/95

      subroutine tfuwind(ipl,xmin,xmax,ymin,ymax,u_min,u_max)

*     **** return valid range of local coordinate u for quadratic shape
*     **** defined in xmin...ymax projected onto plane ipl geometry
      implicit none
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
      integer cmp, ii, ipl
      real u_min, u_max, x(4), y(4), u(4), alpha_cos, alpha_sin,
     +     xmin,xmax,ymin,ymax
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"

      cmp = igede_cmp(ipl)
      if (cmp.lt.1.or.cmp.gt.3)
     +                 print *,' () tfuwind: invalid cmp=', cmp
*     **** angle between u and x
      alpha_cos = fgede_cos(ipl) * fgede_rot(1,ipl)
     +          - fgede_sin(ipl) * fgede_rot(2,ipl)
      alpha_sin = fgede_sin(ipl) * fgede_rot(1,ipl)
     +          + fgede_cos(ipl) * fgede_rot(2,ipl)
*     **** calculate valid u range
      x(1) = xmin
      y(1) = ymin
      x(2) = xmax
      y(2) = ymin
      x(3) = xmax
      y(3) = ymax
      x(4) = xmin
      y(4) = ymax
      do ii=1,4
       u(ii) = x(ii) * alpha_cos - y(ii) * alpha_sin
      enddo

      u_min = min(u(1),u(2),u(3),u(4))
      u_max = max(u(1),u(2),u(3),u(4))

      end



