// ********************************************************************
//
//  Routine:      rc99AECAL
//  Author:       T.Oest/D.Samtleben
//
//  Description:  ECAL stand alone reconstruction
//
//  Modification:
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
//#include "care/ECALTuning.hh"

extern "C" {
void careevnt1_();
void careevnt2_();
}

//void matchRsegCare();

//*****************************************************************
// function
//*****************************************************************

int rc99AECAL(int level) {

//==================================================================
// 1. pedestals (not necessary)
//==================================================================

  //  ECALTuning::evnt();

//==================================================================
// 2. ECAL stand alone reconstruction
//==================================================================

  careevnt1_();

//==================================================================
// 2. Select the tracks (RSEG entries) to match
//==================================================================

  //  matchRsegCare();

//==================================================================
// 3. ECAL reconstruction using tracks
//==================================================================

    careevnt2_();


     return 0;
}
